       subroutine  A1s_wf_sum 
     &  (q0,qv,kt1,ks1,p_m,kt2,ks2,p_r,kt3,ks3,kj,a1s_re,a1s_im,ifl)
******************************************************************
* inputs 
* q0 - energy of virtual photon
* qv - momentum of virtual photon 
* ifl = 1 initializes the wave function, 2- resets the kj, 
*       3- as in A0s_wf initializes the amplitudes, but now said ampl.
* ifl = 0 calculates 
* kti - (i=1,2,3) isospins(1->proton,-1->neutron)
* ks1,ks2,ks3 - spin projection of 1,2,3 nucleon -1-> -1/2, 1-> 1/2
* kj - total spin  projection of he3 -1-> -1/2, 1-> 1/2
* p_m - missing momentum vector
* p_r - one of the recoil momentum vector 
* a0s_re, a0s_im - real and imaginary parts of the amiltitude_0
*/par/pi,pm,pmp,pmn,tm   : pi and masses(constants)
*******************************************************************
      external un23_re_a1phi,un23_im_a1phi
      dimension p_m(3),p_r(3),BB(10),pv1(3),pv2(3)
      common/par/pi,pm,pmp,pmn,tm,eb
      common/vphoton/q2,qq0,qqv
      common/conf/it1,is1,it2,is2,it3,is3,ij
      common/knocked/  p_f_x,  p_f_y,  p_f_z
      common/missing/  p_m_x,  p_m_y,  p_m_z
      common/recoil_r/ p_r_x,  p_r_y,  p_r_z
      common/recoil_s/ p_s_x,  p_s_y,  p_s_z
      common/flag23/ifl23
      common/Bystr/ibys !new flag,when ibys = 1 reads said ampl.from data file
      common/phi23/phi23
      ibys = 1

      a1s_re = 0.0
      a1s_im = 0.0
      if(ifl.eq.1)then
      call 
     & wf_he3_nb(kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,wfre,wfim,ifl)
      return
      elseif(ifl.eq.2)then
      call 
     & wf_he3_nb(kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,wfre,wfim,ifl)
      return
      elseif(ifl.eq.3)then
       call Bystricky_dat(0.01,0.,-1,BB) ! initialization
      return
      endif
      q2  = qv**2 - q0**2
      qq0 = q0
      qqv = qv
        it1    = kt1
        is1    = ks1
        it2    = kt2
        is2    = ks2
        it3    = kt3
        is3    = ks3
        ij     = kj

        p_m_x =  p_m(1)
        p_m_y =  p_m(2)
        p_m_z =  p_m(3)

        p_r_x =  p_r(1)
        p_r_y =  p_r(2)
        p_r_z =  p_r(3)

        p_s_x = -(p_m_x + p_r_x)  
        p_s_y = -(p_m_y + p_r_y) 
        p_s_z = -(p_m_z + p_r_z) 

        p_f_x = p_m_x
        p_f_y = p_m_y
        p_f_z = p_m_z + qv

     
      ifl23 = 2
      if(kt2.eq.1.and.kt3.eq.1) ifl23=1
*     ifl23 = 2 --> pn, 1 --> pp (for recoiled nucleon pair pair)
    

      phi23a = 0.0
      phi23b = 2.0*pi
      call qgaus(un23_re_a1phi,phi23a,phi23b,sum_re)

      phi23a = 0.0
      phi23b = 2.0*pi
      call qgaus(un23_im_a1phi,phi23a,phi23b,sum_im)
 
      fc = 1.0
      a1s_re = fc*sum_re/(8.0*pi)
      a1s_im = fc*sum_im/(8.0*pi)

      return
      end

      function un23_re_a1phi(phi23)
      external th23_a,th23_b,un23_re_a1
      common/par/pi,pm,pmp,pmn,tm,eb
      common/phi23/phi23a
      phi23a = phi23
      eps23  = 0.05
      th23a  = 0.0
      th23b  = pi 
      call gadap(th23a,th23b,un23_re_a1,eps23,sum_re)
      un23_re_a1phi = sum_re
      return
      end

      function un23_im_a1phi(phi23)
      external th23_a,th23_b,un23_im_a1
      common/par/pi,pm,pmp,pmn,tm,eb
      common/phi23/phi23a
      phi23a = phi23
      eps23  = 0.05
      th23a  = 0.0
      th23b  = pi 
      call gadap(th23a,th23b,un23_im_a1,eps23,sum_im)
      un23_im_a1phi = sum_im
      return
      end


      function un23_re_a1(th23)
*     function un23_re_a1(phi23,th23)
      dimension pv1(3), pv2(3)
      common/par/pi,pm,pmp,pmn,tm,eb
      common/vphoton/q2,q0,qv
      common/conf/mt1,ms1,mt2,ms2,mt3,ms3,mj
      common/missing/  p_m_x,  p_m_y,  p_m_z
      common/recoil_r/ p_r_x,  p_r_y,  p_r_z
      common/recoil_s/ p_s_x,  p_s_y,  p_s_z
      common/flag23/ifl
      common/phi23/phi23
      un23_re_a1 = 0.0
      p_rs_x = (p_r_x - p_s_x)/2.0
      p_rs_y = (p_r_y - p_s_y)/2.0
      p_rs_z = (p_r_z - p_s_z)/2.0
      p_rs   = sqrt(p_rs_x**2 + p_rs_y**2 + p_rs_z**2)
      p_23   = p_rs
      p_23_x = p_23*sin(th23)*cos(phi23)
      p_23_y = p_23*sin(th23)*sin(phi23)
      p_23_z = p_23*cos(th23)

      p_2_x = p_23_x + (p_r_x + p_s_x)/2.0
      p_2_y = p_23_y + (p_r_y + p_s_y)/2.0
      p_2_z = p_23_z + (p_r_z + p_s_z)/2.0
      
      pv1(1) = p_m_x
      pv1(2) = p_m_y
      pv1(3) = p_m_z

      pv2(1) = p_2_x
      pv2(2) = p_2_y
      pv2(3) = p_2_z
*     ~~~~~~~~~~~~~~~~~~  Calculating s and t and u  ~~~~~~~~~~~~~~~
      p_2 = p_2_x**2 + p_2_y**2 + p_2_z**2
      E_2 = sqrt(p_2+pm**2)

      p_s = p_s_x**2 + p_s_y**2 + p_s_z**2
      E_s = sqrt(p_s+pm**2)

      p_r = p_r_x**2 + p_r_y**2 + p_r_z**2
      E_r = sqrt(p_r+pm**2)

        if(ifl.eq.1)then          ! pp case
        s = 2.*(pmp**2+E_s*E_r - p_s_x*p_r_x -p_s_y*p_r_y -p_s_z*p_r_z)
        t = 2.* pm**2 -
     &       2.*(E_2*E_r - p_2_x*p_r_x - p_2_y*p_r_y - p_2_z*p_r_z)
        elseif(ifl.eq.2)then      ! pn case (for a while the same as pp)
        s = 2.* pm**2+2.0*(E_r*E_s - 
     &                p_r_x*p_s_x -p_r_y*p_s_y -p_r_z*p_s_z) 
        t =  2.* pm**2 - 
     &       2.*(E_2*E_r - p_2_x*p_r_x - p_2_y*p_r_y - p_2_z*p_r_z)
        endif
      
*      u = 4.*pm**2 - s - t

             ifl = 1
             md  = 2
*~~~~~~~~~~~~~~~~~~~~~~~~~  PP ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if(ifl.eq.1) then 
          ins = -22 ! no Coulumb effects are included
                   
          sum =  0.0
*          do is2=1,-1,-2
*          do is3=1,-1,-2
           is2 = ms2
           is3 = ms3

      irs = 121
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
      irs = 122
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        
            wfre = wf1_re_r + wf1_re_s
            wfim = wf1_im_r + wf1_im_s
*            call
*     &      wf_he3_nb(mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,wfre,wfim,0)
              ! f_pp is a Feynman f in GeV-2
            call  f_NN_diff_said(is2,is3,ms2,ms3, 
     &                           s,t,f_pp_re,f_pp_im,ins)  
            f_til_re =  -(s-4.*pm**2)/8./pi*f_pp_im
            f_til_im =   (s-4.*pm**2)/8./pi*f_pp_re

           
           sum = sum + 0.5*(wfre*f_til_re - wfim*f_til_im)*sin(th23)
*          0.5 accounts ofr pp indentities
*          enddo
*          enddo
*~~~~~~~~~~~~~~~~~~~~~~~~ END PP ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          
*~~~~~~~~~~~~~~~~~~~~~~~~~  PN ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        elseif(ifl.eq.2) then ! SAID ELAS_PN and CHEX_PN
          ins = 21

          sum = 0.0
*          do is2=-1,1,2
*          do is3=-1,1,2
           is2 = ms2
           is3 = ms3

*~~~~~~~~~~                 ELASTIC         ~~~~~~~~~~~~~~~~~~~~~~~~~~
      irs = 22
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
      irs = 21
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        
            wfre_el = wf1_re_r + wf1_re_s
            wfim_el = wf1_im_r + wf1_im_s

            call  f_NN_diff_said(is2,is3,ms2,ms3,
     &                           s,t,f_pn_el_re,f_pn_el_im,ins) 
            f_til_el_re =  -(s-4.*pm**2)/8./pi*f_pn_el_im
            f_til_el_im =   (s-4.*pm**2)/8./pi*f_pn_el_re
*~~~~~~~~~~             CHARGE EXCHANGE         ~~~~~~~~~~~~~~~~~~~~~~~
* Here we dont need to include the charge exchange explicitely, since
* elastic contribution at \theta_cm>90 accounts for it 
* automaticaly
***********************************************************************
*      irs = 22
*      call  A1_wf(q0,qv,mt1,ms1,pv1,-mt2,is2,pv2,-mt3,is3,mj,
*     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
*      irs = 21
*      call  A1_wf(q0,qv,mt1,ms1,pv1,-mt2,is2,pv2,-mt3,is3,mj,
*     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        
*            wfre_chex = wf1_re_r + wf1_re_s
*            wfim_chex = wf1_im_r + wf1_im_s
* 
*
*    	     call f_NN_diff_said_chex(is2,is3,ms2,ms3,
*     &                           s,t,f_pn_chex_re,f_pn_chex_im)
*
*            sn = 1.0
*            f_til_chex_re =  -sn*(s-4.*pm**2)/8./pi*f_pn_chex_im
*            f_til_chex_im =   sn*(s-4.*pm**2)/8./pi*f_pn_chex_re
**********************************************************************

            sum = sum + 
     &            sin(th23)*(wfre_el*f_til_el_re - wfim_el*f_til_el_im)

*          enddo
*          enddo
*~~~~~~~~~~~~~~~~~~~~~~~~ END PN ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        endif
        un23_re_a1 = sum
  
      return
      end


      function un23_im_a1(th23)
      dimension pv1(3), pv2(3)
      common/par/pi,pm,pmp,pmn,tm,eb
      common/vphoton/q2,q0,qv
       common/conf/mt1,ms1,mt2,ms2,mt3,ms3,mj
      common/missing/  p_m_x,  p_m_y,  p_m_z
      common/recoil_r/ p_r_x,  p_r_y,  p_r_z
      common/recoil_s/ p_s_x,  p_s_y,  p_s_z
      common/flag23/ifl
      common/phi23/phi23
      un23_im_a1 = 0.0
      p_rs_x = (p_r_x - p_s_x)/2.0
      p_rs_y = (p_r_y - p_s_y)/2.0
      p_rs_z = (p_r_z - p_s_z)/2.0
      p_rs   = sqrt(p_rs_x**2 + p_rs_y**2 + p_rs_z**2)
      p_23   = p_rs
      p_23_x = p_23*sin(th23)*cos(phi23)
      p_23_y = p_23*sin(th23)*sin(phi23)
      p_23_z = p_23*cos(th23)

      p_2_x = p_23_x + (p_r_x + p_s_x)/2.0
      p_2_y = p_23_y + (p_r_y + p_s_y)/2.0
      p_2_z = p_23_z + (p_r_z + p_s_z)/2.0
      
      pv1(1) = p_m_x
      pv1(2) = p_m_y
      pv1(3) = p_m_z

      pv2(1) = p_2_x
      pv2(2) = p_2_y
      pv2(3) = p_2_z

*     ~~~~~~~~~~~~~~~~~~  Calculating s and t and u  ~~~~~~~~~~~~~~~
      p_2 = p_2_x**2 + p_2_y**2 + p_2_z**2
      E_2 = sqrt(p_2+pm**2)

      p_s = p_s_x**2 + p_s_y**2 + p_s_z**2
      E_s = sqrt(p_s+pm**2)

      p_r = p_r_x**2 + p_r_y**2 + p_r_z**2
      E_r = sqrt(p_r+pm**2)

        if(ifl.eq.1)then          ! pp case
        s = 2.*(pmp**2+E_s*E_r - p_s_x*p_r_x -p_s_y*p_r_y -p_s_z*p_r_z)
        t = 2.* pm**2 -
     &       2.*(E_2*E_r - p_2_x*p_r_x - p_2_y*p_r_y - p_2_z*p_r_z)
        elseif(ifl.eq.2)then     ! pn case
        s = 2.* pm**2+2.0*(E_r*E_s - 
     &                p_r_x*p_s_x -p_r_y*p_s_y -p_r_z*p_s_z) 
        t =  2.* pm**2 - 
     &       2.*(E_2*E_r - p_2_x*p_r_x - p_2_y*p_r_y - p_2_z*p_r_z)
        endif
      
*      u = 4.*pm**2 - s - t
             ifl = 1
             md  = 2

*~~~~~~~~~~~~~~~~~~~~~~~~~  PP ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if(ifl.eq.1) then 
          ins = - 22 ! no Coulomb effects are included

          sum = 0.0                            
*          do is2=1,-1,-2
*          do is3=1,-1,-2
           is2 =  ms2
           is3 =  ms3

      irs = 121
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
      irs = 122
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        
            wfre = wf1_re_r + wf1_re_s
            wfim = wf1_im_r + wf1_im_s

            call  f_NN_diff_said(is2,is3,ms2,ms3, 
     &                           s,t,f_pp_re,f_pp_im,ins)  
            f_til_re =  -(s-4.*pm**2)/8./pi*f_pp_im
            f_til_im =  (s-4.*pm**2)/8./pi*f_pp_re
          
           sum = sum + 0.5*(wfre*f_til_im + wfim*f_til_re)*sin(th23)
*          0.5 accounts for pp identities
*          enddo
*          enddo
*~~~~~~~~~~~~~~~~~~~~~~~~ END PP ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

*~~~~~~~~~~~~~~~~~~~~~~~~~  PN ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        elseif(ifl.eq.2) then ! SAID ELAS_PN and CHEX_PN
          ins = 21
          
          sum = 0.0
*          do is2=-1,1,2
*          do is3=-1,1,2
           is2 = ms2
           is3 = ms3

*~~~~~~~~~~                 ELASTIC         ~~~~~~~~~~~~~~~~~~~~~~~~~~
      irs = 22
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
      irs = 21
      call  A1_wf(q0,qv,mt1,ms1,pv1,mt2,is2,pv2,mt3,is3,mj,
     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        

            wfre_el = wf1_re_r + wf1_re_s
            wfim_el = wf1_im_r + wf1_im_s

            call  f_NN_diff_said(is2,is3,ms2,ms3,
     &                           s,t,f_pn_el_re,f_pn_el_im,ins) 
            f_til_el_re =  -(s-4.*pm**2)/8./pi*f_pn_el_im
            f_til_el_im =   (s-4.*pm**2)/8./pi*f_pn_el_re

*~~~~~~~~~~             CHARGE EXCHANGE         ~~~~~~~~~~~~~~~~~~~~~~~
* Here we dont need to include the charge exchange explicitely, since
* elastic contribution at \theta_cm>90 accounts for it 
* automaticaly
***********************************************************************
*      irs = 22
*      call  A1_wf(q0,qv,mt1,ms1,pv1,-mt2,is2,pv2,-mt3,is3,mj,
*     &                             wf1_re_r,wf1_im_r,md,ifl,irs)
*      irs = 21
*          call  A1_wf(q0,qv,mt1,ms1,pv1,-mt2,is2,pv2,-mt3,is3,mj,
*     &                             wf1_re_s,wf1_im_s,md,ifl,irs)        
*            wfre_chex = wf1_re_r + wf1_re_s
*            wfim_chex = wf1_im_r + wf1_im_s
*
*    	     call f_NN_diff_said_chex(is2,is3,ms2,ms3,
*     &                           s,t,f_pn_chex_re,f_pn_chex_im)
*
*            sn = 1.0
*            f_til_chex_re =   -sn*(s-4.*pm**2)/8./pi*f_pn_chex_im
*            f_til_chex_im =    sn*(s-4.*pm**2)/8./pi*f_pn_chex_re
*----------------------------------------------------------------------
            sum = sum + 
     &            sin(th23)*(wfre_el*f_til_el_im + wfim_el*f_til_el_re)
*          enddo
*          enddo
*~~~~~~~~~~~~~~~~~~~~~~~~ END PN ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        endif

        un23_im_a1 = sum
  
      return
      end

        function th23_a1(phi)
        th23_a1 = 0.0
        return
        end

        function th23_b1(phi)
        th23_b1 = acos(-1.0)
        return
        end
