      program pro_test
      implicit none
      common/par/pi,pm,pmp,pmn,tm,eb
      real pi,pm,pmp,pmn,tm,eb
      real thsa,phisa
      real ei,epr,sn,theta_e,q2,q0,qv,x
      real p_f,theta_fe,phi_fe
      real cs_qe,sn_qe,phi_qe
      real cs_fq,sn_fq,cs_phi_fq,sn_phi_fq
      real pfx,pfy,pfz
      real p_i_x,p_i_y,p_i_z,p_i,p_i_c,p_i_t
      real TA_1,Tf,Em,em_ev,pf_ev
      real crspl,crsmn,crs,crs_s
      real asym,asymn
      integer icon,ipol,ith3
      integer ktf
      real thsa_e,phisa_e, cs_thsa,sn_thsa,cs_phisa,sn_phisa
      real dg,eps
      dg = 180.0/acos(-1.0)

      icon = -1  ! initialization
      ith3 = 1 !He3 -1 H3

      call ehenx(ei,q2,q0,ipol,thsa,phisa,ktf,pfx,pfy,pfz,crspl,crsmn,
     &              crs,ith3,icon,eps)
*******************************************************************************
* The above initialization defines also the values of
* pi = pi,  pm = mass of proton, pmp = mass of proton 
* pmn = mass of neutron, tm = mass of he3, eb = |binding energy| of He3
* 
* All these quantities used in common/par/
*******************************************************************************
      
      eps = 0.1 ! accuracy of integrations in eheN_un

********************************************************************************
*    target polarization angle with respect to incoming electron
********************************************************************************
        thsa_e  = 0.*pi/180.0 ! polar angle of target polarization vector
        phisa_e = pi    ! azimuthal angle of target polarization vector
        ipol = 0  !0 - no polarization, 1 - polarization
********************************************************************************
* type of knock-out nucleon
********************************************************************************
      ktf  = 1 ! -1 neutron !1 !proton   


*********************************************************************
*  kinematics in the lab reference frame with z||k_e,  k'_e is in the 
*  (xy) plane with phi_e = 0.0
*********************************************************************

      ei      = 2.08           ! initial electron energy
      epr     = 1.19          ! scattered electron energy
      theta_e =50.6 *pi/180.0 ! scattered electron angle in rad

      q2   = 4.0*ei*epr*sin(theta_e/2)**2       !Q2
      q0   = ei - epr            ! transfered energy virtual photon energy
      qv   = sqrt(q2+q0**2)      ! transfered momentum
 7    x    = q2/2.0/pm/q0       ! Bjorken x
 
*******************************************************************
* Angles of q vs k_e
*******************************************************************
        cs_qe     = (ei - epr*cos(theta_e))/qv
        sn_qe     = epr*sin(theta_e)/qv
        phi_qe    = pi 


********************************************************************
* Defining polarization angles with respect to q
********************************************************************
        cs_thsa = cs_qe*cos(thsa_e) +
     &            sn_qe*sin(thsa_e)*cos(phi_qe-phisa_e)
        sn_thsa = sqrt(1.0-cs_thsa**2)
        
        thsa  = acos(cs_thsa)
        
        phisa = 0.0
        if(sn_qe.ne.0.0.and.sn_thsa.ne.0.0)then
        cs_phisa = (cos(thsa_e) - cs_qe*cs_thsa)/sn_qe/sn_thsa

        if(cs_phisa.ge.1.0000)cs_phisa = 1.0
        if(cs_phisa.le.-1.000)cs_phisa = -1.0
        sn_phisa = sin(thsa_e)*sin(phisa_e)/sn_thsa
        phisa = acos(cs_phisa)
        if(sn_phisa.lt.0.0)phisa = 2.0*pi-phisa
        endif

*        print *,"polarization angles vs q",thsa*dg, phisa*dg
**************************************************************************
 
        p_f       =  1.52 ! final momentum of the  knock-out nucleon
        
        theta_fe      =  34.5*pi/180.0 ! polar angle of the nucleon vs initial electron
        phi_fe        = 180.0*pi/180.0 ! azimuthal ange of nucleon in the ref frame with k_e || z
***************************************************************************


***************************************************************************
* recalculating in the reference frame in which q||z
***************************************************************************
        cs_fq = cos(theta_fe)*cs_qe  + sin(theta_fe)*sn_qe
     &                                  *cos(phi_fe-phi_qe)
                          sn_fq = 0.0
       if(cs_fq**2.lt.1.0)sn_fq = sqrt(1.0-cs_fq**2)
        

        cs_phi_fq = 1.0
        sn_phi_fq = 0.0

        if(sn_qe.ne.0.0.and.sn_fq.ne.0.0)then
        cs_phi_fq = (cos(theta_fe) - cs_fq*cs_qe)/(sn_fq*sn_qe)
        sn_phi_fq = sin(theta_fe)/sn_fq * sin(phi_fe)
        endif
        if(cs_phi_fq.gt.1.0) cs_phi_fq = 1.0
        if(cs_phi_fq.le.-1.0)cs_phi_fq = -1.0

****************************************************************************
* momentum of knocked-out nucleon in cartesian coordinates
****************************************************************************
        pfx = p_f*sn_fq*cs_phi_fq
        pfy = p_f*sn_fq*sn_phi_fq
        pfz = p_f*cs_fq
****************************************************************************
* momentum of initial (in PWIA) nucleon in cartesian coordinates
****************************************************************************
        p_i_x = pfx
        p_i_y = pfy
        p_i_z = pfz - qv
        p_i = sqrt(p_i_x**2 + p_i_y**2 + p_i_z**2)
      
        
 
        TA_1 = sqrt(4.0*pm**2 + p_i**2) - 2.0*pm ! T_{A-1}
        Tf  = sqrt(pm**2 + p_f**2) - pm
        
        Em = q0 - Tf - TA_1    ! missing energy  q0-Tf - T_{A-1}, T kinetic energy
*       Em should be positive !

        crspl = 0.0;crsmn=0.0;crs=0.0

       icon = 1        ! calculating in PWIA 
      
      call ehenx(ei,q2,q0,ipol,thsa,phisa,ktf,pfx,pfy,pfz,crspl,crsmn,
     &               crs,ith3,icon,eps)
      asym = 0.0
      
      if(ipol.ne.0.0.and.crspl+crsmn.ne.0.0) then
      asym  = (crspl-crsmn)/(crspl+crsmn) ! asymmetry
      crs_s = (crspl+crsmn)/2.0
      endif



      print *,ei,epr,theta_e*dg,p_f,theta_fe*dg,q2,x,Em,p_i,crs

      end


	subroutine kine_q0(q2,pr,thr,q0,ifl)
        common/par/pi,pm,pmp,pmn,tm,eb
        common/electron_k/eil,erl,ue
 	ifl   = 1
        dm = 1.875628
	er    = sqrt(pm**2 + pr**2)
   	arm_a = -q2 + dm**2 - 2.0*er*dm
	arm_b = 2.0*(dm-er)
	arm_g = -2.0*pr*cos(thr)

*	if(arm_g.eq.0.0)then
	if(arm_g**2.le.0.00001)then
	q0    = - arm_a/arm_b
	if(q0.lt.0.0.or.q0.gt.eil)return
	ifl   = 0.0
	return
	endif
	A     = arm_b**2 - arm_g**2
	B     = 2.0*arm_a*arm_b
	C     = arm_a**2 - q2*arm_g**2
	if(A.eq.0.0)then
	q0 = -C/B
	if(q0.lt.0.or.q0.gt.eil)return
 	else
   	call  squar_eq(a,b,c,x1,x2,i_test)
	if(i_test.eq.1)return

*	write(6,*)'xx',thr*180.0/pi,a,b,c,x1,x2
    	q0 = x2
	test  = (arm_a + q0*arm_b)/arm_g  
	if(test.lt.0.0.or.q0.lt.0.0.or.q0.gt.eil)then
     	q0 = x1
	test  = (arm_a + q0*arm_b)/arm_g  
	if(test.lt.0.0.or.q0.lt.0.0.or.q0.gt.eil)return
	endif
	endif
	ifl   = 0	
 	return
 	end




      SUBROUTINE RSTART(I,J,K,L)
      REAL U(97)
      COMMON /SET1/ U,C,CD,CM
      INTEGER*4 I,J,K,L,M
      DO 2 II = 1,97
      S = 0.
      T = .5
      DO 3 JJ = 1,24
         M = MOD(MOD(I*J,179)*K,179)
         I = J
         J = K
         K = M
         L = MOD(53*L+1,169)
         IF(MOD(L*M,64).GE.32) S = S+T
 3       T = .5*T
 2    U(II) = S
      C = 362436./16777216.
      CD = 7654321./16777216.
      CM = 16777213./16777216.
      RETURN
      END


      FUNCTION RANDOM_NUM()
C*******************************************************
C
C   This function generates a random number. 
C
C   Example of usage:  RAN = RANDOM_NUM()
C   This may be done repeatedly throughout a program
C   for continually different random numbers.  
C
C   Taken from a Florida State article
C   G. Marsaglia and A. Zaman, Toward a Universal Random
C   Number Generator. FSU-SCRI-87-50.  9-18-87.
C*******************************************************
       REAL U(97)
       COMMON /SET1/ U,C,CD,CM
       DATA I1,J2,K3,L4,ISTART/12,34,56,78,1/
       DATA I,J/97,33/
       real random_num
       IF (ISTART.EQ.1) THEN
         CALL RSTART(I1,J2,K3,L4)
        ISTART = 0   
       ENDIF
       UNI = U(I) - U(J)
       IF(UNI.LT.0.) UNI = UNI + 1
       U(I) = UNI
       I = I-1
       IF(I.EQ.0) I = 97
       J = J-1
       IF(J.EQ.0) J = 97
       C = C-CD
       IF(C.LT.0.) C = C+CM
       UNI = UNI - C
       IF(UNI.LT.0) UNI = UNI+1
       RANDOM_NUM = UNI
       RETURN
       END

